#line 1 "C:/Documents and Settings/Administrator/Desktop/EmbeddedLab/MikroC/PIC16F1827/UsingInternalFVRforLM34/LM34_Sensor.c"
#line 10 "C:/Documents and Settings/Administrator/Desktop/EmbeddedLab/MikroC/PIC16F1827/UsingInternalFVRforLM34/LM34_Sensor.c"
sbit LCD_RS at RB2_bit;
sbit LCD_EN at RB3_bit;
sbit LCD_D4 at RB4_bit;
sbit LCD_D5 at RB5_bit;
sbit LCD_D6 at RB6_bit;
sbit LCD_D7 at RB7_bit;
sbit LCD_RS_Direction at TRISB2_bit;
sbit LCD_EN_Direction at TRISB3_bit;
sbit LCD_D4_Direction at TRISB4_bit;
sbit LCD_D5_Direction at TRISB5_bit;
sbit LCD_D6_Direction at TRISB6_bit;
sbit LCD_D7_Direction at TRISB7_bit;



 char message1[] = "Temp.";
 char *Temp = "000.0 F";
 unsigned ADC_Value, Temp_F;

void main() {

 ANSELA = 0b00000001;
 TRISA = 0b00100001;
 ANSELB = 0b00000000;
 TRISB = 0b00000000;


 FVRCON = 0b11000010 ;


 ADCON1.ADNREF = 0;
 ADCON1.ADPREF0 = 1;
 ADCON1.ADPREF1 = 1;
 ADCON1.ADCS0 = 0;
 ADCON1.ADCS1 = 0;
 ADCON1.ADCS2 = 0;
 ADCON1.ADFM = 1;


 ADCON0.CHS0 = 0;
 ADCON0.CHS1 = 0;
 ADCON0.CHS2 = 0;
 ADCON0.CHS3 = 0;
 ADCON0.CHS4 = 0;
 ADCON0.ADON = 1;


 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,2,message1);

 do {

 ADCON0.F1 = 1;
 while (ADCON0.F1);
 ADC_Value = (ADRESH << 8) + ADRESL;
 Temp_F = ADC_Value * 10/5;
 Temp[0] = Temp_F/1000 + 48;
 Temp[1] = (Temp_F/100)%10 + 48;
 Temp[2] = (Temp_F/10)%10 + 48;
 Temp[4] = Temp_F%10 + 48;
 if (Temp[0] == '0')
 Temp[0] = ' ';
 if (Temp[0] == ' ' && Temp[1] == '0')
 Temp[1] = ' ';
 Temp[5] = 223;
 LCD_Out(2,2, Temp);
 Delay_ms(1000);
 } while(1);


}
