
_main:

;LM34_Sensor.c,29 :: 		void main() {
;LM34_Sensor.c,31 :: 		ANSELA = 0b00000001;  // RA0 analog input
	MOVLW      1
	MOVWF      ANSELA+0
;LM34_Sensor.c,32 :: 		TRISA  = 0b00100001;  // RA0, RA5 inputs
	MOVLW      33
	MOVWF      TRISA+0
;LM34_Sensor.c,33 :: 		ANSELB = 0b00000000;  // PORTB all digital outputs
	CLRF       ANSELB+0
;LM34_Sensor.c,34 :: 		TRISB  = 0b00000000;  // PORTB all outputs
	CLRF       TRISB+0
;LM34_Sensor.c,37 :: 		FVRCON = 0b11000010 ;
	MOVLW      194
	MOVWF      FVRCON+0
;LM34_Sensor.c,40 :: 		ADCON1.ADNREF  = 0; // Vref- is connected to ground
	BCF        ADCON1+0, 2
;LM34_Sensor.c,41 :: 		ADCON1.ADPREF0 = 1; // Vref+ is 4.096 V
	BSF        ADCON1+0, 0
;LM34_Sensor.c,42 :: 		ADCON1.ADPREF1 = 1;
	BSF        ADCON1+0, 1
;LM34_Sensor.c,43 :: 		ADCON1.ADCS0   = 0; // Use conversion clock, Fosc/2
	BCF        ADCON1+0, 4
;LM34_Sensor.c,44 :: 		ADCON1.ADCS1   = 0; // Fosc = 500 KHz
	BCF        ADCON1+0, 5
;LM34_Sensor.c,45 :: 		ADCON1.ADCS2   = 0;
	BCF        ADCON1+0, 6
;LM34_Sensor.c,46 :: 		ADCON1.ADFM    = 1;  // result is right Justified
	BSF        ADCON1+0, 7
;LM34_Sensor.c,49 :: 		ADCON0.CHS0 = 0;
	BCF        ADCON0+0, 2
;LM34_Sensor.c,50 :: 		ADCON0.CHS1 = 0;
	BCF        ADCON0+0, 3
;LM34_Sensor.c,51 :: 		ADCON0.CHS2 = 0;
	BCF        ADCON0+0, 4
;LM34_Sensor.c,52 :: 		ADCON0.CHS3 = 0;
	BCF        ADCON0+0, 5
;LM34_Sensor.c,53 :: 		ADCON0.CHS4 = 0;
	BCF        ADCON0+0, 6
;LM34_Sensor.c,54 :: 		ADCON0.ADON = 1;  // enable A/D converter
	BSF        ADCON0+0, 0
;LM34_Sensor.c,57 :: 		Lcd_Init();        // Initialize LCD
	CALL       _Lcd_Init+0
;LM34_Sensor.c,58 :: 		Lcd_Cmd(_LCD_CLEAR);             // CLEAR display
	MOVLW      1
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;LM34_Sensor.c,59 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);        // Cursor off
	MOVLW      12
	MOVWF      FARG_Lcd_Cmd_out_char+0
	CALL       _Lcd_Cmd+0
;LM34_Sensor.c,60 :: 		Lcd_Out(1,2,message1);            // Write message1 in 1st row
	MOVLW      1
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVLW      _message1+0
	MOVWF      FARG_Lcd_Out_text+0
	MOVLW      hi_addr(_message1+0)
	MOVWF      FARG_Lcd_Out_text+1
	CALL       _Lcd_Out+0
;LM34_Sensor.c,62 :: 		do {
L_main0:
;LM34_Sensor.c,64 :: 		ADCON0.F1 = 1;     // start conversion, GO/DONE = 1
	BSF        ADCON0+0, 1
;LM34_Sensor.c,65 :: 		while (ADCON0.F1); // wait for conversion
L_main3:
	BTFSS      ADCON0+0, 1
	GOTO       L_main4
	GOTO       L_main3
L_main4:
;LM34_Sensor.c,66 :: 		ADC_Value = (ADRESH << 8) + ADRESL;
	MOVF       ADRESH+0, 0
	MOVWF      R1
	CLRF       R0
	MOVF       ADRESL+0, 0
	ADDWF      R0, 1
	MOVLW      0
	ADDWFC     R1, 1
	MOVF       R0, 0
	MOVWF      _ADC_Value+0
	MOVF       R1, 0
	MOVWF      _ADC_Value+1
;LM34_Sensor.c,67 :: 		Temp_F = ADC_Value * 10/5;
	MOVLW      10
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	CALL       _Mul_16x16_U+0
	MOVLW      5
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	CALL       _Div_16x16_U+0
	MOVF       R0, 0
	MOVWF      _Temp_F+0
	MOVF       R1, 0
	MOVWF      _Temp_F+1
;LM34_Sensor.c,68 :: 		Temp[0] = Temp_F/1000 + 48;
	MOVF       _Temp+0, 0
	MOVWF      FLOC__main+0
	MOVF       _Temp+1, 0
	MOVWF      FLOC__main+1
	MOVLW      232
	MOVWF      R4
	MOVLW      3
	MOVWF      R5
	CALL       _Div_16x16_U+0
	MOVLW      48
	ADDWF      R0, 1
	MOVF       FLOC__main+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__main+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
;LM34_Sensor.c,69 :: 		Temp[1] = (Temp_F/100)%10 + 48;
	MOVLW      1
	ADDWF      _Temp+0, 0
	MOVWF      FLOC__main+0
	MOVLW      0
	ADDWFC     _Temp+1, 0
	MOVWF      FLOC__main+1
	MOVLW      100
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVF       _Temp_F+0, 0
	MOVWF      R0
	MOVF       _Temp_F+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVLW      10
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	CALL       _Div_16x16_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
	MOVLW      48
	ADDWF      R0, 1
	MOVF       FLOC__main+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__main+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
;LM34_Sensor.c,70 :: 		Temp[2] = (Temp_F/10)%10 + 48;
	MOVLW      2
	ADDWF      _Temp+0, 0
	MOVWF      FLOC__main+0
	MOVLW      0
	ADDWFC     _Temp+1, 0
	MOVWF      FLOC__main+1
	MOVLW      10
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVF       _Temp_F+0, 0
	MOVWF      R0
	MOVF       _Temp_F+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVLW      10
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	CALL       _Div_16x16_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
	MOVLW      48
	ADDWF      R0, 1
	MOVF       FLOC__main+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__main+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
;LM34_Sensor.c,71 :: 		Temp[4] = Temp_F%10 + 48;
	MOVLW      4
	ADDWF      _Temp+0, 0
	MOVWF      FLOC__main+0
	MOVLW      0
	ADDWFC     _Temp+1, 0
	MOVWF      FLOC__main+1
	MOVLW      10
	MOVWF      R4
	MOVLW      0
	MOVWF      R5
	MOVF       _Temp_F+0, 0
	MOVWF      R0
	MOVF       _Temp_F+1, 0
	MOVWF      R1
	CALL       _Div_16x16_U+0
	MOVF       R8, 0
	MOVWF      R0
	MOVF       R9, 0
	MOVWF      R1
	MOVLW      48
	ADDWF      R0, 1
	MOVF       FLOC__main+0, 0
	MOVWF      FSR1L
	MOVF       FLOC__main+1, 0
	MOVWF      FSR1H
	MOVF       R0, 0
	MOVWF      INDF1+0
;LM34_Sensor.c,72 :: 		if (Temp[0] == '0')                       // if Temp[0] = '0' then
	MOVF       _Temp+0, 0
	MOVWF      FSR0L
	MOVF       _Temp+1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	XORLW      48
	BTFSS      STATUS+0, 2
	GOTO       L_main5
;LM34_Sensor.c,73 :: 		Temp[0] = ' ';                        // insert blank character to Temp[0]
	MOVF       _Temp+0, 0
	MOVWF      FSR1L
	MOVF       _Temp+1, 0
	MOVWF      FSR1H
	MOVLW      32
	MOVWF      INDF1+0
L_main5:
;LM34_Sensor.c,74 :: 		if (Temp[0] == ' ' && Temp[1] == '0')     // if Temp[0] is blank and Temp[1] =
	MOVF       _Temp+0, 0
	MOVWF      FSR0L
	MOVF       _Temp+1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	XORLW      32
	BTFSS      STATUS+0, 2
	GOTO       L_main8
	MOVLW      1
	ADDWF      _Temp+0, 0
	MOVWF      FSR0L
	MOVLW      0
	ADDWFC     _Temp+1, 0
	MOVWF      FSR0H
	MOVF       INDF0+0, 0
	XORLW      48
	BTFSS      STATUS+0, 2
	GOTO       L_main8
L__main10:
;LM34_Sensor.c,75 :: 		Temp[1] = ' ';                                       // '0' then
	MOVLW      1
	ADDWF      _Temp+0, 0
	MOVWF      FSR1L
	MOVLW      0
	ADDWFC     _Temp+1, 0
	MOVWF      FSR1H
	MOVLW      32
	MOVWF      INDF1+0
L_main8:
;LM34_Sensor.c,76 :: 		Temp[5] = 223;
	MOVLW      5
	ADDWF      _Temp+0, 0
	MOVWF      FSR1L
	MOVLW      0
	ADDWFC     _Temp+1, 0
	MOVWF      FSR1H
	MOVLW      223
	MOVWF      INDF1+0
;LM34_Sensor.c,77 :: 		LCD_Out(2,2, Temp);
	MOVLW      2
	MOVWF      FARG_Lcd_Out_row+0
	MOVLW      2
	MOVWF      FARG_Lcd_Out_column+0
	MOVF       _Temp+0, 0
	MOVWF      FARG_Lcd_Out_text+0
	MOVF       _Temp+1, 0
	MOVWF      FARG_Lcd_Out_text+1
	CALL       _Lcd_Out+0
;LM34_Sensor.c,78 :: 		Delay_ms(1000);
	MOVLW      163
	MOVWF      R12
	MOVLW      85
	MOVWF      R13
L_main9:
	DECFSZ     R13, 1
	GOTO       L_main9
	DECFSZ     R12, 1
	GOTO       L_main9
;LM34_Sensor.c,79 :: 		} while(1);
	GOTO       L_main0
;LM34_Sensor.c,82 :: 		}
	GOTO       $+0
; end of _main
